//
// proj.i: SWIG interface file for PROJ.4 projection library.
//

%module proj
%{
#include <projects.h>
%}

%include typemaps.i
%include constraints.i

%typemap(perl5,in) char ** {
	AV *tempav;
	I32 len;
	int i;
	SV  **tv;

	if (!SvROK($source))
	    croak("$source is not an array.");
        if (SvTYPE(SvRV($source)) != SVt_PVAV)
	    croak("$source is not an array.");
        tempav = (AV*)SvRV($source);
	len = av_len(tempav);
	$target = (char **) malloc((len+2)*sizeof(char *));
	for (i = 0; i <= len; i++) {
	    tv = av_fetch(tempav, i, 0);	
	    $target[i] = (char *) SvPV(*tv,PL_na);
        }
	$target[i] = 0;
};

%typemap(perl5, freearg) char ** {
  free($source);
}

#define RAD_TO_DEG	57.29577951308232
#define DEG_TO_RAD	.0174532925199432958

typedef struct { double u, v; }	projUV;

projUV pj_fwd(projUV pnt, PJ *pj);
projUV pj_inv(projUV pnt, PJ *pj);
void pj_free(PJ *pj);
PJ *pj_init(int nargs, char **args);

%addmethods projUV {
  projUV() {
    return (projUV *)malloc(sizeof(projUV));
  }

  ~projUV() {
    free(self);
  }
}